# VERDANT WIZARD
#
# Every 30s, summon a magic spell book, whenever a spellbook is nearby,
# boss will be inmune to damage:
#   - The spells books will target the player and choose between 
#       random attacks:
#           1. Fire bolt: A fireball that leaves a fire spot on collision.
#           2. Frost bolt: An ice ball that freezes the player on collision.
#           3. Shock bolt: A ball of energy that weakens the player on collision.
#           
# Every 60s, it will cast one of two random spells:
#
#   - Mana Barrage: Seeking projectile that upon collision with a player will attempt
#                to heal the boss.
#
#   - Boss will summon a spell book when player does a lot of damage
#
#   
#   OLD CONCEPTS:
#
#   - Teleport to itself
#   - Tempest: Summons a breeze that pushes player back, levitation is applied, deals 
#              damage to players who aren't on the ground. (Breeze with scale 20, Invulnerable)
#
#   - Blizzard: Summons an ice storm that slows down players, players who don't move for
#               3s will be frozen and be damaged.
#
#   - Meteor Strike: Summons a meteor shower that deal massive damage to players.
#               
#   - Eldritch Seal: Stops the player from receiving any positive effects

# Trigger Boss Intro if player comes nearby
execute as @s[tag=!INTRO_IS_FINISHED,tag=!INTRO_PlayerHasComeClose] if entity @a[distance=..15] run tag @s add INTRO_PlayerHasComeClose

# BOSS INTRO:
execute as @s[tag=!INTRO_IS_FINISHED,tag=INTRO_PlayerHasComeClose] run function faction:entity_cmds/boss/boss_intro/boss_check

# CHECK FOR HP (This inits Boss Outro)
function faction:entity_cmds/boss/boss_health_check/_main

# Initialize the Boss Death
execute as @s[tag=BOSS_InitOutro] run function faction:entity_cmds/boss/boss_outro/_main


# DELETE IF NO GUIDE MARKER IS NEARBY
function faction:entity_cmds/bossndungs/delete_if_no_bossndungs_marker

# Shield Cmds
execute as @s[tag=BOSS_VerdantWizard_SHIELDED] run function faction:entity_cmds/boss/verdant_wizard/shield_cmds/_main

scoreboard players add @s[tag=INTRO_IS_FINISHED] Boss_Sb_1 1

# Spawn a mana bolt if player deals damage to boss (75% chance)
execute as @s[predicate=faction:75per] if entity @a[distance=..15,scores={PLAYER_DamageDealt=80..}] run function faction:entity_cmds/boss/verdant_wizard/mana_barrage/cast_angry


# If player is nearby, slow the boss
execute if entity @a[distance=..3.5] run effect give @s slowness 1 255 true

# Boss will always have slow falling and weakness
effect give @s slow_falling 1 255 true
effect give @s weakness 1 255 true
effect give @s resistance 1 0 true

# Constant Particle Effects
execute as @s[predicate=faction:25per] run particle enchant ~ ~1.5 ~ 0.65 0.75 0.65 0 1


# Spawn Spell Books
execute as @s[scores={Boss_Sb_1=100}] run playsound minecraft:entity.illusioner.prepare_mirror ambient @a[distance=..15] ~ ~1 ~ 10 1
execute as @s[scores={Boss_Sb_1=100..104}] run function faction:entity_cmds/boss/verdant_wizard/book_spawner/_spawn

# Chance to Activate Shield
execute as @s[scores={Boss_Sb_1=300},predicate=faction:75per] run function faction:entity_cmds/boss/verdant_wizard/shield_cmds/_activate

# Mana Barrage (To replenish Health)
execute as @s[scores={Boss_Sb_1=700}] run function faction:entity_cmds/boss/verdant_wizard/mana_barrage/_cast_caster

# Chance to Activate Shield
execute as @s[scores={Boss_Sb_1=900},predicate=faction:75per] run function faction:entity_cmds/boss/verdant_wizard/shield_cmds/_activate

# Restart Cycle
execute as @s[scores={Boss_Sb_1=1000..}] run scoreboard players reset @s Boss_Sb_1


# SOUND EFFECTS

# HURT
execute if entity @a[distance=..15,scores={PLAYER_DamageDealt=1..}] run playsound entity.evoker.hurt ambient @a[distance=..15] ~ ~1 ~ 1 0.85


# # # # #
