


# This tags this entity with BED_ZONE_IS_NOT_NEAR
# if there isn't a bed zone nearby. This is so
# this player doesn't respawn if there aren't any beds.
execute unless entity @e[tag=BED_ZONE,limit=1,sort=nearest,distance=..150] run tag @s add BED_ZONE_IS_NOT_NEAR

# Death Message
tellraw @a [{"selector":"@s","color":"white"},{"text":" has been slain by ","color":"white"},{"selector":"@a[limit=1,sort=nearest]","color":"white"}]

# If entity HAS died before, just kill and return 0
execute as @s[tag=HAS_DIED_1] run kill @s
execute as @s[tag=HAS_DIED_1] run return 0

# This is so this player doesn't respawn if there aren't any beds.
execute as @s[tag=BED_ZONE_IS_NOT_NEAR] run kill @s
execute as @s[tag=BED_ZONE_IS_NOT_NEAR] run return 0




# VFX for the death
playsound entity.player.hurt ambient @a[distance=..15] ~ ~1 ~ 5 1
function faction:entity_cmds/fake_player/death_cmds/entity_cmds/summon

# Spawn loot as if the fplayer has been killed for real.
execute if block ~ ~ ~ #faction:walkthrough run loot spawn ~ ~ ~ kill @s 

# Teleport to the nearest "bed" 
tp @s @e[tag=BED_ZONE,limit=1,sort=nearest,distance=..150]

# Delete the armor and the loot table is set to empty
data merge entity @s {ArmorItems:[{id:"minecraft:bedrock",count:1},{id:"minecraft:bedrock",count:1},{id:"minecraft:bedrock",count:1},{id:"minecraft:turtle_helmet",count:1}],ArmorDropChances:[0.000F,0.000F,0.000F,0.000F]}
data merge entity @s {DeathLootTable:"faction:entities/empty"}

# This tag allows the game to tell whether this function has been
# executed before or not
tag @s add HAS_DIED_1

function faction:entity_cmds/fake_player/hold_air

# Change the AI to be Generic
tag @s remove AI_Health_Smart
tag @s remove AI_Guard_Post
tag @s add AI_Generic

# Change this entity's health to the regular 20f
effect give @s instant_damage 1 255 true
attribute @s max_health base set 40.0
data merge entity @s {Health:40}



# CLEAR ANY EFFECT
effect clear @s


# FINISH ABILITIES

# BRAWLER
function faction:entity/abilities/brawler/commander_order/cd_cmds/cd_end
function faction:entity/abilities/brawler/overpower/fplayer_deathreset
function faction:entity/abilities/brawler/savage_leap/fplayer_death_end


# FENCER
function faction:entity/abilities/fencer/direct_focus/entity_cmds/end
function faction:entity/abilities/fencer/en_guarde/fplayer_reset_end
function faction:entity/abilities/fencer/en_guarde/fplayer_reset_end
function faction:entity/abilities/fencer/hindering_state/caster_cmds/end
function faction:entity/abilities/fencer/lunge/end
tag @s remove Ab_Fencer_QuickCharge_Caster
scoreboard players reset @s Ab_QuickCharge_1


# MAGE
function faction:entity/abilities/mage/blizzard/afflicted_cmds/end
function faction:entity/abilities/mage/eruption/afflicted/end
function faction:entity/abilities/mage/fireball/hit_entity_end
function faction:entity/abilities/mage/ground_snare/afflicted_cmds/fplayer_reset_end
function faction:entity/abilities/mage/iceblast/hit_entity_end


# ROGUE
function faction:entity/abilities/rogue/arcane_quiver/caster_finish
scoreboard players reset @s Ab_ChainArrow_1
tag @s remove Ab_ChainArrow_Caster
scoreboard players reset @s Ab_ExplosiveArrow_1
tag @s remove Ab_ExplosiveArrow_Caster
scoreboard players reset @s Ab_FireCharge_1
tag @s remove Ab_FireCharge_Caster
scoreboard players reset @s Ab_PiercingShot_1
tag @s remove Ab_PiercingShot_Caster
function faction:entity/abilities/rogue/possesed_quiver/caster_finish
function faction:entity/abilities/rogue/splintering_quiver/caster_finish


# SCOUT
function faction:entity/abilities/scout/shuriken_barrage/end
tag @s remove Ab_Recall_Caster
scoreboard players reset @s Ab_Recall_1 
scoreboard players reset @s Ab_PoisonVial_1
tag @s remove Ab_Scout_PoisonVial_Caster
scoreboard players reset @s Ab_PinDown_1
tag @s remove Ab_PinDown_Caster
scoreboard players reset @s Ab_DecayShot_1
tag @s remove Ab_DecayShot_Caster









